﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Prova3Lib;
using Prova3Lib.MVC;

namespace Prova3
{
    public class Controller : ControllerBase
    {
        public Controller(View view)
            : base(view)
        {
        }

        public new Model Model
        {
            get { return (Model) base.Model; }
        }

        public void InsertShape(string typeName)
        {
            IShape shape = ShapeFactory.Instance.CreateShape(typeName);
            Model.Add(shape);
        }

        public void ChangeShape(IShape shape)
        {
            using (PropertyForm propertyForm = new PropertyForm())
            {
                propertyForm.SelectedObject = shape;
                propertyForm.ShowDialog();
            }
        }

        public void RemoveShape(IShape shape)
        {
            Model.Remove(shape);
        }
    }
}
