﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Prova3Lib;

namespace Prova3
{
    public partial class MainForm : Form
    {
        private Controller _controller;
        private static Model _model = new Model();

        public MainForm()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            _view.Model = _model;
            _controller = new Controller(_view);

            foreach (string shapeName in ShapeFactory.Instance.GetShapesNames())
            {
                insertToolStripMenuItem.DropDownItems.Add(shapeName, null, OnInsert_Click);
            }
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MainForm mainForm = new MainForm();
            mainForm.Show();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void modifyToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
            ToolStripMenuItem senderMenuItem = (ToolStripMenuItem) sender;
            senderMenuItem.DropDownItems.Clear();
            foreach (IShape shape in _model.GetShapes())
            {
                ToolStripItem item = senderMenuItem.DropDownItems.Add(shape.Name, null, OnModify_Click);
                item.Tag = shape;
            }
        }

        private void deleteToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
            ToolStripMenuItem senderMenuItem = (ToolStripMenuItem) sender;
            senderMenuItem.DropDownItems.Clear();
            foreach (IShape shape in _model.GetShapes())
            {
                ToolStripItem item = senderMenuItem.DropDownItems.Add(shape.Name, null, OnDelete_Click);
                item.Tag = shape;
            }
        }

        private void OnInsert_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem senderMenuItem = (ToolStripMenuItem) sender;
            string shapeName = (string) senderMenuItem.Text;
            _controller.InsertShape(shapeName);
        }

        private void OnModify_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem senderMenuItem = (ToolStripMenuItem) sender;
            IShape shape = (IShape) senderMenuItem.Tag;
            _controller.ChangeShape(shape);
        }

        private void OnDelete_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem senderMenuItem = (ToolStripMenuItem) sender;
            IShape shape = (IShape) senderMenuItem.Tag;
            _controller.RemoveShape(shape);
        }
    }
}
