﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Prova3Lib;
using Prova3Lib.MVC;
using Prova3Lib.Drawers;

namespace Prova3
{
    public partial class View : ViewBase
    {
        public View()
        {
            InitializeComponent();
        }

        public new Model Model
        {
            get { return (Model) base.Model; }
            set { base.Model = value; }
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            if(Model==null)
                return;
            foreach (IShape shape in Model.GetShapes())
            {
                IDrawer drawer = DrawerFactory.Instance.GetDrawerFor(shape);
                drawer.Draw(e.Graphics, shape);
            }
        }
    }
}
